mrrl

Minimal Reliable Reproducible Linux
git clone https://ccx.te2000.cz/git/mrrl
Log | Files | Refs | Submodules | README

opam (6037B)


      1 #!/usr/bin/env pthbs-build
      2 #+busybox.7f0e4d86f69de7624b0468018b9933c3e3c1757c8ff73938746c292196f916dd
      3 #+busybox-bzip2.52d2053dff44277d3c6f700eec6807d2c64c226e0f1bf589372ff5ff625be40e
      4 #+busybox-gzip.085fc42ce36be284c89a9dec6889cca59dedd07b9ba93a21d3198c4adcac5840
      5 #+busybox-lzop.bccd8f86de85a74d466d34f802ab1ea355f0a9d9886bdfa4d7bb4a785d695be6
      6 #+busybox-unzip.237a4ec36283b7fbdb85df583c7c77c0aaf70d335b1cbae09a40a9bb4b6c82bb
      7 #+busybox-xz.db25ed2ffbfc91e7b5cff54faf2e80de59ab5b15167c2c5bb338fa1ee62de122
      8 #+busybox-cpio.307e9495bcd9b79fd9559882115d55d22c5b687e08886e696f1e53d8db7eebcd
      9 #+busybox-dpkg.3aec8347093bb5b774a0c25795cdf9e624268a3b04cc48e867d74e4e06461db7
     10 #+busybox-rpm.8435251ea7058aea0cbcd41478b144b1a15c5aa121509af887847c0ef45bf5aa
     11 #+busybox-tar.c77139157bce13db8820740b756572c22e29cfbd8bb8c2a3b22b465b70e2eae9
     12 #+busybox-ed.4ac872215d7b9c8096c4cfd508434fbd2e825aebd9a9ea8589a0033b8e50aac2
     13 #+busybox-sed.14269a860b3706f7122b827818365fecaa0e62ce5bc3273e89948685c0953f2d
     14 #+busybox-vi.7e41b306c9c47aaaa281aa8347b9fa6dca260788fd73f53a7ba9260b315627ee
     15 #+busybox-xxd.9df3407fd75b89cb640d65870298eaba77327d6e387d25d8ce1ebab01cb47857
     16 #+busybox-process-extra.65afeaded3cb8fdeea327262f28f08e50f18d51a2b456ea97b293d200c7f558e
     17 #+busybox-procps.e5dc609521d29d8aec8253147269314439131c088a6beeacc172fc07594c4a37
     18 #+busybox-psmisc.7d760b69f45bb1b8d458f2f408b9cb3a42e919e8022f0508c440a5fd20ebb66f
     19 #+busybox-ash.fd5d266905d40248735e0e2e1ae22165b6f0d42c0bacb652660f69f39c1ee71e
     20 #+busybox-bc.6f2fe17efab2237c3036eba1c37d432d696d1b5dba130e21365016ceae0a3184
     21 #+busybox-coreutils.7e581faa6901f832a2a022d72b2858c3091f47afc80a4a463adb2f2a68f1843d
     22 #+busybox-coreutils-extra.5ab183b839676b0780a9a83d75cc345a06221fa34627c44aa3732c4a5a47f9b9
     23 #+busybox-daemontools.bcea69c867a61fe1d49d2f6a27e406959c484ed20d54fd7c0341828d3cdbd428
     24 #+busybox-grep.ac20e6a4295eb7fb0a09d700e10e5fe55e2009d2858e0a1525e461d4914e820b
     25 #+busybox-misc.7f0588b97809fac8061c489b686424de1a7dd17d8eb3431aae56513c7288f1e7
     26 #+busybox-sh.288f0583edc783a176bbbc59a3e854b186258ba2605291377a545cc3191c3d52
     27 #+busybox-util-linux-unpriv.5a286246aa7204f7fa8c9a247f1c93c751979690a65200030f29e255645c1eae
     28 #+busybox-findutils.207f73a9f41a8f9e279072e920cbf0c38ba6516734fa3cf2c1faf55565613487
     29 #+nawk.84c186be0a6d09a951a8c6a5377d16b0ba0a9e476e6b554c0c832d6407ebb5b2
     30 #+diffutils.fc3b1b10f669e9e7b906baeaccda743718beb2525f062132853123f854aa4cbf
     31 #+patch.96351292cca51303a6659875ff00da38adbcc491e1966e0db30cea5469b8c123
     32 #+gnu-make.17b0037e8a3f24180cb7bb9ddb488039d540ba905aecca0315de313adfbae81c
     33 #+musl-cross-make.19d51dec5328ccacd41d47d7f24e33bac084aebefb839cb3fecb6573577b831a
     34 #+getconf.389beb94b7d7302b1512629a3a0a728627efa094ac6376c9cad06ea7c4405ef7
     35 #+ocaml.5d68a619356fa3da8a61022cde7b7b58e6d4e05bd0cad320650fe78e2359e764
     36 #+dune.bdbad0945fefe62e7931a5893921985b9d646d47879854db04bd18b4afd912dc
     37 #@untar:-z:sha256:c4d053029793c714e4e7340b1157428c0f90783585fb17f35158247a640467d9:.
     38 
     39 
     40 # - build script start -
     41 
     42 check_static() {
     43 	local exe || true
     44 	exe=$pthbs_destdir'/versions'/$pthbs_package/$1
     45 	if ! test -f $exe; then
     46 		printf '%s\n' "Error: file '$1' doesn't exist!"
     47 		exit 1
     48 	fi
     49 	local interp_info || true
     50 	interp_info=$(readelf --string-dump=.interp "$exe") || exit $?
     51 	if test x '!=' "x$interp_info"; then
     52 		printf '%s\n' "Error: '$1' is a dynamic binary!"
     53 		exit 1
     54 	fi
     55 }
     56 
     57 prefix=/versions/$pthbs_package
     58 dest=${pthbs_destdir%/}${prefix}
     59 cd 'opam-full-2.4.1'
     60 
     61 
     62 export DUNE_CACHE=disabled
     63 ./configure \
     64 	--prefix="$prefix" \
     65 	--libdir="$prefix/library.ocaml" \
     66 	--bindir="$prefix/command" \
     67 	--sbindir="$prefix/command" \
     68 	--mandir="$prefix/man" \
     69 	--docdir="$prefix/doc/opam" \
     70 	--datadir="$prefix/data" \
     71 	--datarootdir="$prefix/data" \
     72 	--infodir="$prefix/info" \
     73 	--localedir="$prefix/locale" \
     74 	--localstatedir='/var/pthbs' \
     75 	--with-dune='/versions/dune.bdbad0945fefe62e7931a5893921985b9d646d47879854db04bd18b4afd912dc/command/dune' \
     76 	--with-mccs \
     77 	--with-vendored-deps \
     78 	--enable-static
     79 
     80 
     81 make DUNE_ARGS=--verbose
     82 make DESTDIR="$pthbs_destdir" install
     83 
     84 
     85 
     86 make tests || true
     87 ## dynamic build
     88 #check_static bin/opam
     89 #check_static bin/opam-installer
     90 "$dest/bin/opam" --version
     91 "$dest/bin/opam-installer" --version
     92 
     93 
     94 
     95 cd "$pthbs_destdir/versions/$pthbs_package"
     96 find -type d -o -print | awk -F/ '
     97 BEGIN {
     98 	x["./bin/opam"]=1
     99 	x["./bin/opam-installer"]=1
    100 }
    101 
    102 function r1(s) {
    103 	sub("^[.]/[^/]*", ".", s)
    104 	return s
    105 }
    106 function s1(repl, s) {
    107 	sub("^[.]/[^/]*", "./"repl, s)
    108 	return s
    109 }
    110 function link(src) {
    111 	x[$0]=0
    112 	printf "%s\t%s\n", $0, src
    113 	printf "genlinks >>%s\t%s<<\n", $0, src >>"/dev/stderr"
    114 }
    115 $1!="."{exit 1}
    116 $2 == "env" { link($0); next }
    117 $2 == ".env-template" { link($0); next }
    118 
    119 $2 == "command" { link($0); next }
    120 $2 == "command" { link($0); next }
    121 $2 == "bin" { link(s1("command", $0)); next }
    122 $2 == "sbin" { link(s1("command", $0)); next }
    123 
    124 $2 == "library.so" { link($0); next }
    125 $2 == "library" { link($0); next }
    126 $2 == "lib" && $NF ~ /\.l?a$/ { link(s1("library", $0)); next }
    127 $2 == "lib" && $NF ~ /\.so(\..*)?$/ { link(s1("library.so", $0)); next }
    128 
    129 $2 == "share" && $3 == "info" { link(s1("info", r1($0))); next }
    130 $2 == "share" && $3 == "man" { link(s1("man", r1($0))); next }
    131 $2 == "share" && $3 == "doc" { link(s1("doc", r1($0))); next }
    132 
    133 $2 == "config" { link($0); next }
    134 $2 == "man" { link($0); next }
    135 $2 == "info" { link($0); next }
    136 $2 == "doc" { link($0); next }
    137 $2 == "data" { link($0); next }
    138 $2 == "include" { link($0); next }
    139 
    140 $2 == "share" && $3 ~ /^(icons|terminfo)$/ { link(r1($0)); next }
    141 
    142 $2 == "library.ocaml" { link($0); next }
    143 
    144 $2 == "keys" { link($0); next }
    145 $2 == "zsh" { link($0); next }
    146 $2 == "vimfiles" { link($0); next }
    147 $2 == "icons" { link($0); next }
    148 $2 == "terminfo" { link($0); next }
    149 
    150 
    151 { printf "genlinks ##%s## skipped\n", $0 >>"/dev/stderr" }
    152 
    153 END {
    154 	for(fname in x) { printf "DEBUG: x[\"%s\"]=\"%s\"\n", fname, x[fname] >"/dev/stderr" }
    155 	retcode = 0
    156 	for(fname in x) {
    157 		if(x[fname]) {
    158 			printf "ERROR: missing expected file \"%s\"\n", fname >"/dev/stderr"
    159 			retcode = 3
    160 		}
    161 	}
    162 	exit retcode
    163 }' >.install-links.new
    164 mv .install-links.new .install-links
    165